/*
 * Client shell v1.2
 *
 * (c) Copyright 1998-1999 Stelian Pop <pop@cybercable.fr>.
 *
 * This is distributed under the GNU GENERAL PUBLIC LICENSE (GPL) Version 2
 *
*/
#include <sys/socket.h>
#include <netinet/in.h>
#include <sys/stat.h>
#include <sys/wait.h>
#include <signal.h>
#include <errno.h>
#include <string.h>
#include <unistd.h>
#include <stdio.h>
#include <netdb.h>
#include <pwd.h>
#include <sys/ioctl.h>
#include <sys/time.h>
#include <sys/types.h>

struct sockaddr_in addr;
struct hostent *hp;
struct passwd *pwd;


void talk(int locin, int locout, int remin, int remout) {
  int one=1, a, b, ac=0, bc=0, code, max;
  fd_set readfrom, writeto;
  char bufa[1024], bufb[1024];
  
  
  ioctl(locin, FIONBIO, &one);
  ioctl(locout, FIONBIO, &one);
  ioctl(remin, FIONBIO, &one);
  ioctl(remout, FIONBIO, &one);
  a=1;
  b=2;

  while (a) {

    FD_ZERO(&readfrom);
    FD_ZERO(&writeto);
    max = 0;
    switch (a) {
    case 1:
      FD_SET(remin, &readfrom);
      if (remin > max) max = remin;
      break;
    case 2:
      FD_SET(locout, &writeto);
      if (locout > max) max = locout;
      break;
    }
    switch (b) {
    case 1:
      FD_SET(remout, &writeto);
      if (remout > max) max = remout;
    break;
    case 2:
      FD_SET(locin, &readfrom);
      if (locin > max) max = locin;
      break;
    }

    if (select(max+1, &readfrom, &writeto, 0, 0)==-1) {
      perror("select error");
      exit(1);
    }

    if (FD_ISSET(remin, &readfrom)) {

      ac = read(remin, bufa, sizeof bufa);
      if (ac <= 0) 
        a=0;
      else 
        a=2;

    }
    if (FD_ISSET(remout, &writeto)) {

      code = write(remout, bufb, bc);
      if (code == bc)
        b=2;
      else if ((code == -1)&&(errno != EWOULDBLOCK))
        b=0;
    }
    if (FD_ISSET(locout, &writeto)) {

      code = write(locout, bufa, ac);
      if (code == ac)
        a=1;
      else if ((code == -1)&&(errno != EWOULDBLOCK))
        a=0;
    }
    if (FD_ISSET(locin, &readfrom)) {

      bc = read(locin, bufb, sizeof bufb);
      if (bc <=0)
        b=0;
      else
        b=1;
    }
  }
}


int main(int argc, char *argv[]) {
  int sk_cli, port, i;

  if (argc < 4) {
    fprintf(stderr,"Client shell v1.2\n");
    fprintf(stderr,"(c) Copyright 1998-1999 Stelian Pop <pop@cybercable.fr>.\n\n");
    fprintf(stderr,"cs <host> <port> <commande>\n");
    exit(1);
  }

  sscanf(argv[2], "%d", &port);

  /* Open the socket */
  sk_cli=socket(AF_INET, SOCK_STREAM, 0);
  if (sk_cli==-1) {
    perror("socket error");
    exit(1);
  }

  /* Get the server adress */
  if ((hp=gethostbyname(argv[1]))==NULL) {
    perror("gethostbyname error");
    exit(1);
  }
  
  addr.sin_family=AF_INET;
  addr.sin_port=htons(port);
  memcpy(&addr.sin_addr.s_addr, hp->h_addr, hp->h_length);

  /* Connect to the server */
  if (connect(sk_cli, (struct sockaddr *)&addr, sizeof(addr))==-1) {
    perror("connect error");
    exit(1);
  }

  /* Send the user name */
  pwd = getpwuid(getuid());
  if (pwd == NULL) {
    perror("getpwuid error");
    exit(1);
  }
  if (send(sk_cli, pwd->pw_name, strlen(pwd->pw_name), 0)!=strlen(pwd->pw_name)) {
    perror("send error");
    exit(1);
  }
  if (send(sk_cli, "\0", 1, 0)!=1) {
    perror("send error");
    exit(1);
  }

  /* Send the remote command line */
  for (i=3; i<argc; ++i) {
    if (send(sk_cli, argv[i], strlen(argv[i]), 0)!=strlen(argv[i])) {
      perror("send error");
      exit(1);
    }
    if (send(sk_cli, " ", 1, 0)!=1) {
      perror("send error");
      exit(1);
    }
  }
  if (send(sk_cli, "\0", 1, 0)!=1) {
    perror("send error");
    exit(1);
  }

  talk(0, 1, sk_cli, sk_cli);
  
  /* Close the socket */
  close(sk_cli);
  exit(0);
}
